 /*********************************************************
 *
 * This source code is part of the Carnegie Mellon Robot
 * Navigation Toolkit (CARMEN)
 *
 * CARMEN Copyright (c) 2002 Michael Montemerlo, Nicholas
 * Roy, Sebastian Thrun, Dirk Haehnel, Cyrill Stachniss,
 * and Jared Glover
 *
 * CARMEN is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public 
 * License as published by the Free Software Foundation; 
 * either version 2 of the License, or (at your option)
 * any later version.
 *
 * CARMEN is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more 
 * details.
 *
 * You should have received a copy of the GNU General 
 * Public License along with CARMEN; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, 
 * Suite 330, Boston, MA  02111-1307 USA
 *
 ********************************************************/

char *robd_default_setup_string = 
"[sonar]\n"
"firing_delay = 0\n"
"sonar_sets = sonset0 sonset1 sonset2 sonset3 sonset4 sonset5\n"
"\n"
"[sonset0]\n"
"main_lobe =  209.43\n"
"blind_lobe = 1.74\n"
"side_lobe = 174.53\n"
"blind_lobe_attenuation = 2\n"
"side_lobe_attenuation = 1.2\n"
"range = 10000\n"
"sonars = son0 son1 son2 son3 son4 son5 son6 son7\n"
"son0 = CreateSonar son0 238.006 182.628 0.793353 0.608761 base\n"
"son1 = CreateSonar son1 182.628 238.006 0.608761 0.793353 base\n"
"son2 = CreateSonar son2 114.805 277.164 0.382683 0.92388 base\n"
"son3 = CreateSonar son3 39.1579 297.433 0.130526 0.991445 base\n"
"son4 = CreateSonar son4 -39.1579 297.433 -0.130526 0.991445 base\n"
"son5 = CreateSonar son5 -114.805 277.164 -0.382683 0.92388 base\n"
"son6 = CreateSonar son6 -182.628 238.006 -0.608761 0.793353 base\n"
"son7 = CreateSonar son7 -238.006 182.628 -0.793353 0.608761 base\n"
"\n"
"[sonset1]\n"
"main_lobe =  209.43\n"
"blind_lobe = 1.74\n"
"side_lobe = 174.53\n"
"blind_lobe_attenuation = 2\n"
"side_lobe_attenuation = 1.2\n"
"range = 10000\n"
"sonars = son0 son1 son2 son3 son4 son5 son6 son7\n"
"son0 = CreateSonar son0 238.006 182.628 0.793353 0.608761 base\n"
"son1 = CreateSonar son1 182.628 238.006 0.608761 0.793353 base\n"
"son2 = CreateSonar son2 114.805 277.164 0.382683 0.92388 base\n"
"son3 = CreateSonar son3 39.1579 297.433 0.130526 0.991445 base\n"
"son4 = CreateSonar son4 -39.1579 297.433 -0.130526 0.991445 base\n"
"son5 = CreateSonar son5 -114.805 277.164 -0.382683 0.92388 base\n"
"son6 = CreateSonar son6 -182.628 238.006 -0.608761 0.793353 base\n"
"son7 = CreateSonar son7 -238.006 182.628 -0.793353 0.608761 base\n"
"\n"
"[sonset2]\n"
"main_lobe =  209.43\n"
"blind_lobe = 1.74\n"
"side_lobe = 174.53\n"
"blind_lobe_attenuation = 2\n"
"side_lobe_attenuation = 1.2\n"
"range = 10000\n"
"sonars = son0 son1 son2 son3 son4 son5 son6 son7\n"
"son0 = CreateSonar son0 -277.164 114.805 -0.92388 0.382683 base\n"
"son1 = CreateSonar son1 -297.433 39.1579 -0.991445 0.130526 base\n"
"son2 = CreateSonar son2 -297.433 -39.1579 -0.991445 -0.130526 base\n"
"son3 = CreateSonar son3 -277.164 -114.805 -0.92388 -0.382683 base\n"
"son4 = CreateSonar son4 -238.006 -182.628 -0.793353 -0.608761 base\n"
"son5 = CreateSonar son5 -182.628 -238.006 -0.608761 -0.793353 base\n"
"son6 = CreateSonar son6 -114.805 -277.164 -0.382683 -0.92388 base\n"
"son7 = CreateSonar son7 -39.1579 -297.433 -0.130526 -0.991445 base\n"
"\n"
"[sonset3]\n"
"main_lobe =  209.43\n"
"blind_lobe = 1.74\n"
"side_lobe = 174.53\n"
"blind_lobe_attenuation = 2\n"
"side_lobe_attenuation = 1.2\n"
"range = 10000\n"
"sonars = son0 son1 son2 son3 son4 son5 son6 son7\n"
"son0 = CreateSonar son0 -277.164 114.805 -0.92388 0.382683 base\n"
"son1 = CreateSonar son1 -297.433 39.1579 -0.991445 0.130526 base\n"
"son2 = CreateSonar son2 -297.433 -39.1579 -0.991445 -0.130526 base\n"
"son3 = CreateSonar son3 -277.164 -114.805 -0.92388 -0.382683 base\n"
"son4 = CreateSonar son4 -238.006 -182.628 -0.793353 -0.608761 base\n"
"son5 = CreateSonar son5 -182.628 -238.006 -0.608761 -0.793353 base\n"
"son6 = CreateSonar son6 -114.805 -277.164 -0.382683 -0.92388 base\n"
"son7 = CreateSonar son7 -39.1579 -297.433 -0.130526 -0.991445 base\n"
"\n"
"[sonset4]\n"
"main_lobe =  209.43\n"
"blind_lobe = 1.74\n"
"side_lobe = 174.53\n"
"blind_lobe_attenuation = 2\n"
"side_lobe_attenuation = 1.2\n"
"range = 10000\n"
"sonars = son0 son1 son2 son3 son4 son5 son6 son7\n"
"son0 = CreateSonar son0 39.1579 -297.433 0.130526 -0.991445 base\n"
"son1 = CreateSonar son1 114.805 -277.164 0.382683 -0.92388 base\n"
"son2 = CreateSonar son2 182.628 -238.006 0.608761 -0.793353 base\n"
"son3 = CreateSonar son3 238.006 -182.628 0.793353 -0.608761 base\n"
"son4 = CreateSonar son4 277.164 -114.805 0.92388 -0.382683 base\n"
"son5 = CreateSonar son5 297.433 -39.1579 0.991445 -0.130526 base\n"
"son6 = CreateSonar son6 297.433 39.1579 0.991445 0.130526 base\n"
"son7 = CreateSonar son7 277.164 114.805 0.92388 0.382683 base\n"
"\n"
"[sonset5]\n"
"main_lobe =  209.43\n"
"blind_lobe = 1.74\n"
"side_lobe = 174.53\n"
"blind_lobe_attenuation = 2\n"
"side_lobe_attenuation = 1.2\n"
"range = 10000\n"
"sonars = son0 son1 son2 son3 son4 son5 son6 son7\n"
"son0 = CreateSonar son0 39.1579 -297.433 0.130526 -0.991445 base\n"
"son1 = CreateSonar son1 114.805 -277.164 0.382683 -0.92388 base\n"
"son2 = CreateSonar son2 182.628 -238.006 0.608761 -0.793353 base\n"
"son3 = CreateSonar son3 238.006 -182.628 0.793353 -0.608761 base\n"
"son4 = CreateSonar son4 277.164 -114.805 0.92388 -0.382683 base\n"
"son5 = CreateSonar son5 297.433 -39.1579 0.991445 -0.130526 base\n"
"son6 = CreateSonar son6 297.433 39.1579 0.991445 0.130526 base\n"
"son7 = CreateSonar son7 277.164 114.805 0.92388 0.382683 base\n"
"\n"
"[infrared]\n"
"infrared_sets = irset0 irset1 irset2 irset3 irset4 irset5\n"
"\n"
"[irset0]\n"
"main_lobe = 261.79\n"
"range = 350\n"
"infrareds = ir0 ir1 ir2 ir3 ir4 ir5 ir6 ir7\n"
"ir0 = CreateInfrared ir0 238.006 182.628 0.793353 0.608761 base\n"
"ir1 = CreateInfrared ir1 182.628 238.006 0.608761 0.793353 base\n"
"ir2 = CreateInfrared ir2 114.805 277.164 0.382683 0.92388 base\n"
"ir3 = CreateInfrared ir3 39.1579 297.433 0.130526 0.991445 base\n"
"ir4 = CreateInfrared ir4 -39.1579 297.433 -0.130526 0.991445 base\n"
"ir5 = CreateInfrared ir5 -114.805 277.164 -0.382683 0.92388 base\n"
"ir6 = CreateInfrared ir6 -182.628 238.006 -0.608761 0.793353 base\n"
"ir7 = CreateInfrared ir7 -238.006 182.628 -0.793353 0.608761 base\n"
"\n"
"[irset1]\n"
"main_lobe = 261.79\n"
"range = 350\n"
"infrareds = ir0 ir1 ir2 ir3 ir4 ir5 ir6 ir7\n"
"ir0 = CreateInfrared ir0 238.006 182.628 0.793353 0.608761 base\n"
"ir1 = CreateInfrared ir1 182.628 238.006 0.608761 0.793353 base\n"
"ir2 = CreateInfrared ir2 114.805 277.164 0.382683 0.92388 base\n"
"ir3 = CreateInfrared ir3 39.1579 297.433 0.130526 0.991445 base\n"
"ir4 = CreateInfrared ir4 -39.1579 297.433 -0.130526 0.991445 base\n"
"ir5 = CreateInfrared ir5 -114.805 277.164 -0.382683 0.92388 base\n"
"ir6 = CreateInfrared ir6 -182.628 238.006 -0.608761 0.793353 base\n"
"ir7 = CreateInfrared ir7 -238.006 182.628 -0.793353 0.608761 base\n"
"\n"
"[irset2]\n"
"id = irset1t\n"
"main_lobe = 261.79\n"
"range = 350\n"
"infrareds = ir0 ir1 ir2 ir3 ir4 ir5 ir6 ir7\n"
"ir0 = CreateInfrared ir0 -277.164 114.805 -0.92388 0.382683 base\n"
"ir1 = CreateInfrared ir1 -297.433 39.1579 -0.991445 0.130526 base\n"
"ir2 = CreateInfrared ir2 -297.433 -39.1579 -0.991445 -0.130526 base\n"
"ir3 = CreateInfrared ir3 -277.164 -114.805 -0.92388 -0.382683 base\n"
"ir4 = CreateInfrared ir4 -238.006 -182.628 -0.793353 -0.608761 base\n"
"ir5 = CreateInfrared ir5 -182.628 -238.006 -0.608761 -0.793353 base\n"
"ir6 = CreateInfrared ir6 -114.805 -277.164 -0.382683 -0.92388 base\n"
"ir7 = CreateInfrared ir7 -39.1579 -297.433 -0.130526 -0.991445 base\n"
"\n"
"[irset3]\n"
"main_lobe = 261.79\n"
"range = 350\n"
"infrareds = ir0 ir1 ir2 ir3 ir4 ir5 ir6 ir7\n"
"ir0 = CreateInfrared ir0 -277.164 114.805 -0.92388 0.382683 base\n"
"ir1 = CreateInfrared ir1 -297.433 39.1579 -0.991445 0.130526 base\n"
"ir2 = CreateInfrared ir2 -297.433 -39.1579 -0.991445 -0.130526 base\n"
"ir3 = CreateInfrared ir3 -277.164 -114.805 -0.92388 -0.382683 base\n"
"ir4 = CreateInfrared ir4 -238.006 -182.628 -0.793353 -0.608761 base\n"
"ir5 = CreateInfrared ir5 -182.628 -238.006 -0.608761 -0.793353 base\n"
"ir6 = CreateInfrared ir6 -114.805 -277.164 -0.382683 -0.92388 base\n"
"ir7 = CreateInfrared ir7 -39.1579 -297.433 -0.130526 -0.991445 base\n"
"\n"
"[irset4]\n"
"main_lobe = 261.79\n"
"range = 350\n"
"infrareds = ir0 ir1 ir2 ir3 ir4 ir5 ir6 ir7\n"
"ir0 = CreateInfrared ir0 39.1579 -297.433 0.130526 -0.991445 base\n"
"ir1 = CreateInfrared ir1 114.805 -277.164 0.382683 -0.92388 base\n"
"ir2 = CreateInfrared ir2 182.628 -238.006 0.608761 -0.793353 base\n"
"ir3 = CreateInfrared ir3 238.006 -182.628 0.793353 -0.608761 base\n"
"ir4 = CreateInfrared ir4 277.164 -114.805 0.92388 -0.382683 base\n"
"ir5 = CreateInfrared ir5 297.433 -39.1579 0.991445 -0.130526 base\n"
"ir6 = CreateInfrared ir6 297.433 39.1579 0.991445 0.130526 base\n"
"ir7 = CreateInfrared ir7 277.164 114.805 0.92388 0.382683 base\n"
"\n"
"[irset5]\n"
"main_lobe = 261.79\n"
"range = 350\n"
"infrareds = ir0 ir1 ir2 ir3 ir4 ir5 ir6 ir7\n"
"ir0 = CreateInfrared ir0 39.1579 -297.433 0.130526 -0.991445 base\n"
"ir1 = CreateInfrared ir1 114.805 -277.164 0.382683 -0.92388 base\n"
"ir2 = CreateInfrared ir2 182.628 -238.006 0.608761 -0.793353 base\n"
"ir3 = CreateInfrared ir3 238.006 -182.628 0.793353 -0.608761 base\n"
"ir4 = CreateInfrared ir4 277.164 -114.805 0.92388 -0.382683 base\n"
"ir5 = CreateInfrared ir5 297.433 -39.1579 0.991445 -0.130526 base\n"
"ir6 = CreateInfrared ir6 297.433 39.1579 0.991445 0.130526 base\n"
"ir7 = CreateInfrared ir7 277.164 114.805 0.92388 0.382683 base\n"
"\n"
"[bumper]\n"
"bumper_sets = bumperset0 bumperset1 bumperset2 bumperset3 bumperset4 bumperset5\n"
"\n"
"[bumperset0]\n"
"bumpers = bumperarc bumper8 bumper9 bumper10 bumper11\n"
"bumperarc = CreateBumperArc 8 bumper 0 0 0.6545 2.0944 base\n"
"bumper8 = CreateBumper bumper8 0 0 0.5 0.866 base\n"
"bumper9 = CreateBumper bumper9 0 0 0.5 0.866 base\n"
"bumper10 = CreateBumper bumper10 0 0 -0.5 0.866 base\n"
"bumper11 = CreateBumper bumper11 0 0 -0.5 0.866 base\n"
"\n"
"[bumperset1]\n"
"bumpers = bumperarc\n"
"bumperarc = CreateBumperArc 8 bumper 0 0 0.6545 2.0944 base\n"
"\n"
"[bumperset2]\n"
"bumpers = bumperarc bumper8 bumper9 bumper10 bumper11\n"
"bumperarc = CreateBumperArc 8 bumper 0 0 2.749 2.0944 base\n"
"bumper8 = CreateBumper bumper8 0 0 -1.0 0.0 base\n"
"bumper9 = CreateBumper bumper9 0 0 -1.0 0.0 base\n"
"bumper10 = CreateBumper bumper10 0 0 -0.5 -0.866 base\n"
"bumper11 = CreateBumper bumper11 0 0 -0.5 -0.866 base\n"
"\n"
"[bumperset3]\n"
"bumpers = bumperarc\n"
"bumperarc = CreateBumperArc 8 bumper 0 0 2.749 2.0944 base\n"
"\n"
"[bumperset4]\n"
"bumpers = bumperarc bumper8 bumper9 bumper10 bumper11\n"
"bumperarc = CreateBumperArc 8 bumper 0 0 4.843 2.0944 base\n"
"bumper8 = CreateBumper bumper8 0 0 0.5 -0.866 base\n"
"bumper9 = CreateBumper bumper9 0 0 0.5 -0.866 base\n"
"bumper10 = CreateBumper bumper10 0 0 1.0 0.0 base\n"
"bumper11 = CreateBumper bumper11 0 0 1.0 0.0 base\n"
"\n"
"[bumperset5]\n"
"bumpers = bumperarc\n"
"bumperarc = CreateBumperArc 8 bumper 0 0 4.843 2.0944 base\n";

