/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         odl_parse
#define yylex           odl_lex
#define yyerror         odl_error
#define yydebug         odl_debug
#define yynerrs         odl_nerrs

#define yylval          odl_lval
#define yychar          odl_char

/* Copy the first part of user declarations.  */
#line 1 "gt_overlay_yac.y" /* yacc.c:339  */

/**********************************************************************
 **                                                                  **
 **                         gt_overlay_yac.y                         **
 **                                                                  **
 **                                                                  **
 **        Parser for the overlay description language (odl)         **
 **                                                                  **
 **        See the MissionLab user's manual for details.             **
 **                                                                  **
 **                                                                  **
 **  Written by:  Jonathan M. Cameron                                **
 **                                                                  **
 **  Copyright 1995, 1996, 1997 Georgia Tech Research Corporation    **
 **  Atlanta, Georgia  30332-0415                                    **
 **  ALL RIGHTS RESERVED, See file COPYRIGHT for details.            **
 **                                                                  ** 
 **********************************************************************/

/* $Id: gt_overlay_yac.y,v 1.1.1.1 2008/07/14 16:44:22 endo Exp $ */

extern "C" {
#include <stdio.h>
#include <malloc.h>
#include <stdarg.h>
}

#include "gt_world.h"
#include "gt_scale.h"
#include "gt_measure.h"
#include "console.h"
#include "gt_console_db.h"
#include "3d_vis_wid.h"
#include "convert_scale.h"

extern int odl_lex();
extern void odl_error(char *);
extern void odl_errorf(const char *, ...);
int odl_parse();
double utmx, utmy;
int map_scale_factor = -1;

#line 117 "gt_overlay_yac.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gt_overlay_yac.h".  */
#ifndef YY_ODL_GT_OVERLAY_YAC_H_INCLUDED
# define YY_ODL_GT_OVERLAY_YAC_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int odl_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    SCENARIO = 258,
    SITE = 259,
    ORIGIN = 260,
    GLOBAL_REF_POINT = 261,
    MISSION_AREA = 262,
    LOAD_MAP = 263,
    CONTROL_MEASURES = 264,
    SET_TOKEN = 265,
    ZOOM_FACTOR_TOKEN = 266,
    ATTRACTOR_TOKEN = 267,
    BASKET_TOKEN = 268,
    AA_TOKEN = 269,
    ATK_TOKEN = 270,
    AXIS_TOKEN = 271,
    BOUNDARY_TOKEN = 272,
    BP_TOKEN = 273,
    GAP_TOKEN = 274,
    LDLC_TOKEN = 275,
    OBJ_TOKEN = 276,
    OBSTACLE_TOKEN = 277,
    PL_TOKEN = 278,
    PP_TOKEN = 279,
    SP_TOKEN = 280,
    UTM_TOKEN = 281,
    LAT_TOKEN = 282,
    LON_TOKEN = 283,
    WALL_TOKEN = 284,
    ROOM_TOKEN = 285,
    DOOR_TOKEN = 286,
    HALLWAY_TOKEN = 287,
    CENTERLINE_TOKEN = 288,
    WIDTH_TOKEN = 289,
    EXTENTS_TOKEN = 290,
    HEADING = 291,
    WAYPOINT_FILE_TOKEN = 292,
    SCALE_TOKEN = 293,
    HEIGHTMAP = 294,
    QSTRING = 295,
    IDENTIFIER = 296,
    FILENAME = 297,
    NUMBER = 298,
    OBJECT_TOKEN = 299,
    OBJ_STYLE = 300
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 44 "gt_overlay_yac.y" /* yacc.c:355  */

           float  fval;
      OBJ_STYLES  style;
   gt_Point_list *coords;
            char *strval;
  double utm_coord[2];

#line 211 "gt_overlay_yac.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE odl_lval;

int odl_parse (void);

#endif /* !YY_ODL_GT_OVERLAY_YAC_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 228 "gt_overlay_yac.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  38
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   163

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  46
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  41
/* YYNRULES -- Number of rules.  */
#define YYNRULES  88
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  163

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   300

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    70,    70,    75,    76,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    92,   102,   112,   117,   125,
     133,   137,   147,   156,   167,   188,   199,   203,   204,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   234,
     241,   251,   258,   268,   275,   285,   292,   302,   312,   320,
     331,   341,   348,   358,   366,   377,   384,   394,   401,   412,
     419,   428,   435,   446,   457,   468,   476,   485,   494,   504,
     514,   524,   526,   538,   551,   565,   570,   577,   578
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SCENARIO", "SITE", "ORIGIN",
  "GLOBAL_REF_POINT", "MISSION_AREA", "LOAD_MAP", "CONTROL_MEASURES",
  "SET_TOKEN", "ZOOM_FACTOR_TOKEN", "ATTRACTOR_TOKEN", "BASKET_TOKEN",
  "AA_TOKEN", "ATK_TOKEN", "AXIS_TOKEN", "BOUNDARY_TOKEN", "BP_TOKEN",
  "GAP_TOKEN", "LDLC_TOKEN", "OBJ_TOKEN", "OBSTACLE_TOKEN", "PL_TOKEN",
  "PP_TOKEN", "SP_TOKEN", "UTM_TOKEN", "LAT_TOKEN", "LON_TOKEN",
  "WALL_TOKEN", "ROOM_TOKEN", "DOOR_TOKEN", "HALLWAY_TOKEN",
  "CENTERLINE_TOKEN", "WIDTH_TOKEN", "EXTENTS_TOKEN", "HEADING",
  "WAYPOINT_FILE_TOKEN", "SCALE_TOKEN", "HEIGHTMAP", "QSTRING",
  "IDENTIFIER", "FILENAME", "NUMBER", "OBJECT_TOKEN", "OBJ_STYLE",
  "$accept", "file", "info_part", "info_statement", "scenario_statement",
  "site_statement", "origin_statement", "global_ref_pt_statement",
  "heading_statement", "load_map_statement", "heightmap_statement",
  "scale_statement", "mission_area_statement", "set_zoom_factor_statement",
  "control_measure_part", "control_measure_list",
  "control_measure_statement", "assembly_area_statement",
  "attack_position_statement", "axis_statement",
  "battle_position_statement", "boundary_statement", "gap_statement",
  "ldlc_statement", "objective_statement", "obstacle_statement",
  "passage_point_statement", "basket_statement", "attractor_statement",
  "object_statement", "phase_line_statement", "starting_point_statement",
  "wall_statement", "room_statement", "door_statement",
  "hallway_statement", "waypoint_file_statement", "coordinate_list",
  "coordinate_pair", "utm_coordinate", "name", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300
};
# endif

#define YYPACT_NINF -79

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-79)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
       8,    22,    22,     5,   -26,   -23,    22,    19,   -18,     0,
      10,    42,    -1,   -79,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,    44,    12,
     -79,    21,    30,   -79,    32,   -79,   -79,    47,   -79,   119,
     -79,   -79,    48,    49,   -79,   -79,   -79,   -79,    50,    13,
      13,    22,    22,    22,    22,    22,    22,    22,    22,    13,
      22,    22,    22,    22,    22,    22,    22,    22,    13,   119,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,    66,    68,    53,    54,    55,   -79,    56,    13,    13,
      13,    13,    13,    13,    13,    13,    57,    13,    13,    13,
      13,    13,    13,    69,   -79,    58,   -79,    60,    61,    64,
     -79,   -79,   -79,    14,   -79,    15,    23,    13,    24,    13,
      13,    25,    65,    13,    67,   -79,    27,    13,    13,    13,
      77,   -79,   -79,   -79,    54,   -79,    54,    54,    54,   102,
      54,   -79,   -79,    54,     2,    45,   -79,   103,   -79,   -79,
      71,    13,    13
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     3,     5,     6,     7,     8,     9,    10,
      11,    14,    12,    13,    88,    87,    15,    16,     0,     0,
      18,     0,     0,    21,     0,    20,    23,     0,     1,     0,
       4,     2,     0,     0,    17,    19,    24,    25,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    26,
      27,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    41,    39,    40,    42,    43,    44,    45,    46,    47,
      48,     0,     0,     0,     0,    69,    84,    67,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    80,     0,    28,     0,     0,     0,
      83,    70,    68,    49,    81,    51,    53,    57,    55,     0,
      60,    61,    63,    73,    65,    74,    75,    77,    78,     0,
       0,    85,    86,    22,    50,    82,    52,    54,    56,    58,
      62,    64,    66,    76,     0,     0,    59,     0,    72,    71,
       0,     0,    79
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -79,   -79,   -79,    97,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,    43,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,   -79,
     -79,   -79,   -79,   -79,   -79,   -79,   -79,   -78,   -49,   108,
      63
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    41,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,   123,   124,    96,
      26
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      95,    97,     1,     2,     3,     4,     5,     6,    39,     7,
     106,     1,     2,     3,     4,     5,     6,    31,     7,   115,
      32,   125,   126,   127,   128,    35,   130,   131,    28,   133,
      34,    28,   136,   137,   138,     8,   157,     9,    10,    28,
      28,    28,    38,    36,     8,    94,     9,    10,    29,    28,
      28,    28,    37,    28,   129,    44,    94,   144,   146,   134,
     135,   154,    24,    25,    45,    27,   147,   148,   150,    33,
     153,    42,    43,    46,   145,    47,   145,   145,   145,   145,
     149,   145,   145,   162,   145,   158,   159,   145,   145,   145,
      48,    91,    92,    93,   117,   118,   119,   120,   121,   122,
     132,   140,   139,   141,   142,   145,   161,   143,   151,    40,
     152,    30,   116,   145,    98,    99,   100,   101,   102,   103,
     104,   105,   155,   107,   108,   109,   110,   111,   112,   113,
     114,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,   156,   160,     0,    63,    64,
      65,    66,     0,     0,     0,     0,    67,     0,     0,     0,
       0,     0,     0,    68
};

static const yytype_int16 yycheck[] =
{
      49,    50,     3,     4,     5,     6,     7,     8,     9,    10,
      59,     3,     4,     5,     6,     7,     8,    43,    10,    68,
      43,    99,   100,   101,   102,    43,   104,   105,    26,   107,
      11,    26,   110,   111,   112,    36,    34,    38,    39,    26,
      26,    26,     0,    43,    36,    43,    38,    39,    43,    26,
      26,    26,    42,    26,   103,    43,    43,    43,    43,   108,
     109,   139,    40,    41,    43,     2,    43,    43,    43,     6,
      43,    27,    28,    43,   123,    43,   125,   126,   127,   128,
     129,   130,   131,   161,   133,    40,    41,   136,   137,   138,
      43,    43,    43,    43,    28,    27,    43,    43,    43,    43,
      43,    43,    33,    43,    43,   154,    35,    43,    43,    12,
      43,     3,    69,   162,    51,    52,    53,    54,    55,    56,
      57,    58,    45,    60,    61,    62,    63,    64,    65,    66,
      67,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    43,    43,    -1,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    44
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,    10,    36,    38,
      39,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    40,    41,    86,    86,    26,    43,
      85,    43,    43,    86,    11,    43,    43,    42,     0,     9,
      49,    60,    27,    28,    43,    43,    43,    43,    43,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    29,    30,    31,    32,    37,    44,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    43,    43,    43,    43,    84,    85,    84,    86,    86,
      86,    86,    86,    86,    86,    86,    84,    86,    86,    86,
      86,    86,    86,    86,    86,    84,    62,    28,    27,    43,
      43,    43,    43,    83,    84,    83,    83,    83,    83,    84,
      83,    83,    43,    83,    84,    84,    83,    83,    83,    33,
      43,    43,    43,    43,    43,    84,    43,    43,    43,    84,
      43,    43,    43,    43,    83,    45,    43,    34,    40,    41,
      43,    35,    83
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    46,    47,    48,    48,    49,    49,    49,    49,    49,
      49,    49,    49,    49,    49,    50,    51,    52,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    61,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
      62,    62,    62,    62,    62,    62,    62,    62,    62,    63,
      63,    64,    64,    65,    65,    66,    66,    67,    68,    68,
      69,    70,    70,    71,    71,    72,    72,    73,    73,    74,
      74,    75,    75,    76,    77,    78,    78,    79,    80,    81,
      82,    83,    83,    84,    84,    85,    85,    86,    86
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     3,     2,     3,
       2,     2,     6,     2,     3,     3,     2,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       4,     3,     4,     3,     4,     3,     4,     3,     4,     5,
       3,     3,     4,     3,     4,     3,     4,     2,     3,     2,
       3,     5,     5,     3,     3,     3,     4,     3,     3,     8,
       2,     1,     2,     2,     1,     5,     5,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 15:
#line 93 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if(gt_add_scenario_label((yyvsp[0].strval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add SCENARIO %s", (yyvsp[0].strval));
		      YYABORT;
		      }
		}
#line 1441 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 16:
#line 103 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_site_name((yyvsp[0].strval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add SITE %s", (yyvsp[0].strval));
		      YYABORT;
		      }
		}
#line 1452 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 17:
#line 113 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   origin_x = (yyvsp[-1].fval);
		   origin_y = (yyvsp[0].fval);
		}
#line 1461 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 18:
#line 118 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		  origin_x = (yyvsp[0].utm_coord)[0];
		  origin_y = (yyvsp[0].utm_coord)[1];
		}
#line 1470 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 19:
#line 126 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		 g_ref_latitude = (yyvsp[-1].fval);
		 g_ref_longitude = (yyvsp[0].fval);
	       }
#line 1479 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 20:
#line 133 "gt_overlay_yac.y" /* yacc.c:1646  */
    {origin_heading = (yyvsp[0].fval);}
#line 1485 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 21:
#line 138 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (!load_map(gMapInfo, (yyvsp[0].strval), drawing_area)) {
		      odl_errorf("Error: Unable to LOAD-MAP %s", (yyvsp[0].strval));
		      YYABORT;
		      }
		}
#line 1496 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 22:
#line 148 "gt_overlay_yac.y" /* yacc.c:1646  */
    { printf("Loading a height map: %s %d %d %d %d\n", (yyvsp[-4].strval), (int)(yyvsp[-3].fval), (int)(yyvsp[-2].fval), (int)(yyvsp[-1].fval), (int)(yyvsp[0].fval));
  if (!load_heightmap((yyvsp[-4].strval), (int)(yyvsp[-3].fval), (int)(yyvsp[-2].fval), (int)(yyvsp[-1].fval), (int)(yyvsp[0].fval))) {
  odl_errorf("Error: Unable to load a height map %s", (yyvsp[-4].strval));
  YYABORT;
}
}
#line 1507 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 23:
#line 157 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
	printf("Setting scale to: %d\n", (int)(yyvsp[0].fval));
	map_scale_factor = (int)(yyvsp[0].fval);
	set_meters_per_pixel(map_scale_factor / pixelsPerMeter);
	set_zoom_factor(1.0);
}
#line 1518 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 24:
#line 168 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if ((yyvsp[-1].fval) < 0.0) {
		      odl_errorf("Mission-Area width must be positive (%1.8g)", (yyvsp[-1].fval));
		      YYABORT;
		      }
		   else if ((yyvsp[0].fval) < 0.0) {
		      odl_errorf("Mission-Area height must be positive (%1.8g)", (yyvsp[0].fval));
		      YYABORT;
		      }
		   else {
		      // The two lines below added by Nadeem to 
		      // use the same MISSION-AREA for lat/lon computations
		      map_width = (yyvsp[-1].fval); 
		      map_height = (yyvsp[0].fval);
		      set_mission_area_size((yyvsp[-1].fval), (yyvsp[0].fval));
		      }
		}
#line 1540 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 25:
#line 189 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (!set_zoom_factor((double)(yyvsp[0].fval)/100.0)) {
		      odl_errorf("Error setting zoom factor (%1.8g)", (yyvsp[0].fval));
		      YYABORT;
		      }
		}
#line 1551 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 49:
#line 235 "gt_overlay_yac.y" /* yacc.c:1646  */
    { 
		   if(gt_add_assembly_area((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Assembly Area %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1562 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 50:
#line 242 "gt_overlay_yac.y" /* yacc.c:1646  */
    { 
		   if(gt_add_assembly_area((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Assembly Area %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1573 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 51:
#line 252 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if(gt_add_attack_position((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Attack Point %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1584 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 52:
#line 259 "gt_overlay_yac.y" /* yacc.c:1646  */
    { 
		   if(gt_add_attack_position((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Attack Point %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1595 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 53:
#line 269 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_axis((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Axis %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1606 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 54:
#line 276 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_axis((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Axis %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1617 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 55:
#line 286 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_battle_position((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Battle Position %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1628 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 56:
#line 293 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_battle_position((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Battle Position %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1639 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 57:
#line 303 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_boundary((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Boundary %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1650 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 58:
#line 313 "gt_overlay_yac.y" /* yacc.c:1646  */
    { 
		   (yyvsp[-1].coords)->next = (yyvsp[0].coords);
		   if (gt_add_gap((yyvsp[-2].strval), (yyvsp[-1].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Gap %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1662 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 59:
#line 321 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   (yyvsp[-2].coords)->next = (yyvsp[-1].coords);
		   if (gt_add_gap((yyvsp[-3].strval), (yyvsp[-2].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Gap %s", (yyvsp[-3].strval));
		      YYABORT;
		      }
		}
#line 1674 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 60:
#line 332 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_ldlc((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		      odl_errorf("Unable to add LD/LC %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1685 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 61:
#line 342 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_objective((yyvsp[-1].strval), (yyvsp[0].coords), -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Objective %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1696 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 62:
#line 349 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_objective((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Objective %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1707 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 63:
#line 359 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_obstacle((yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval)) !=  GT_SUCCESS) {
		      odl_errorf("Unable to add Obstacle (x=%1.9g, y=%1.9g, r=%1.9g)", 
				 (yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval));
		      YYABORT;
		      }
		}
#line 1719 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 64:
#line 367 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		 if (gt_add_obstacle((yyvsp[-2].coords)->x, (yyvsp[-2].coords)->y, (yyvsp[-1].fval), (yyvsp[0].fval)) !=  GT_SUCCESS) {
		   odl_errorf("Unable to add Obstacle (x=%1.9g, y=%1.9g, r=%1.9g, height = %1.9g)", 
			      (yyvsp[-2].coords)->x, (yyvsp[-2].coords)->y, (yyvsp[-1].fval), (yyvsp[0].fval));
		   YYABORT;
		 }
               }
#line 1731 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 65:
#line 378 "gt_overlay_yac.y" /* yacc.c:1646  */
    {  
		   if(gt_add_passage_point((yyvsp[-1].strval), (yyvsp[0].coords)->x, (yyvsp[0].coords)->y, -1.0) != GT_SUCCESS) {
		      odl_errorf("Unable to add Passage Point %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1742 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 66:
#line 385 "gt_overlay_yac.y" /* yacc.c:1646  */
    { 
		   if(gt_add_passage_point((yyvsp[-2].strval), (yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Passage Point %s", (yyvsp[-2].strval));
		      YYABORT;
		      }
		}
#line 1753 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 67:
#line 395 "gt_overlay_yac.y" /* yacc.c:1646  */
    {  
		   if(gt_add_basket((yyvsp[0].coords)->x, (yyvsp[0].coords)->y, -1) != GT_SUCCESS) {
		      odl_errorf("Unable to add Basket");
		      YYABORT;
		      }
		}
#line 1764 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 68:
#line 402 "gt_overlay_yac.y" /* yacc.c:1646  */
    {  
		   if(gt_add_basket((yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Basket");
		      YYABORT;
		      }
		}
#line 1775 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 69:
#line 413 "gt_overlay_yac.y" /* yacc.c:1646  */
    {  
		   if(gt_add_attractor((yyvsp[0].coords)->x, (yyvsp[0].coords)->y, -1) != GT_SUCCESS) {
		      odl_errorf("Unable to add Attractor");
		      YYABORT;
		      }
		}
#line 1786 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 70:
#line 420 "gt_overlay_yac.y" /* yacc.c:1646  */
    {  
		   if(gt_add_attractor((yyvsp[-1].coords)->x, (yyvsp[-1].coords)->y, (yyvsp[0].fval)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Attractor");
		      YYABORT;
		      }
		}
#line 1797 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 71:
#line 428 "gt_overlay_yac.y" /* yacc.c:1646  */
    {  
      if(gt_add_object((yyvsp[-3].coords)->x, (yyvsp[-3].coords)->y, (yyvsp[-2].fval), (yyvsp[0].strval), (yyvsp[-1].style)) != GT_SUCCESS) 
      {
         odl_errorf("Unable to create object");
	 YYABORT;
      }
   }
#line 1809 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 72:
#line 435 "gt_overlay_yac.y" /* yacc.c:1646  */
    {  
      if(gt_add_object((yyvsp[-3].coords)->x, (yyvsp[-3].coords)->y, (yyvsp[-2].fval), (yyvsp[0].strval), (yyvsp[-1].style)) != GT_SUCCESS) 
      {
         odl_errorf("Unable to create object");
	 YYABORT;
      }
   }
#line 1821 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 73:
#line 447 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   if (gt_add_phase_line((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		      odl_errorf("Unable to add Phase Line %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1832 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 74:
#line 458 "gt_overlay_yac.y" /* yacc.c:1646  */
    { 
		   if (gt_add_starting_point((yyvsp[-1].strval), (yyvsp[0].coords)->x, (yyvsp[0].coords)->y) != GT_SUCCESS) {
		      odl_errorf("Unable to add Starting Point %s", (yyvsp[-1].strval));
		      YYABORT;
		      }
		}
#line 1843 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 75:
#line 469 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		if (gt_add_wall((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Wall %s", (yyvsp[-1].strval));
		  YYABORT;
		}
	      }
#line 1854 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 76:
#line 477 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		if (gt_add_wall((yyvsp[-2].strval), (yyvsp[-1].coords), (yyvsp[0].fval)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Wall %s", (yyvsp[-2].strval));
		  YYABORT;
		}
	      }
#line 1865 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 77:
#line 486 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		if (gt_add_room((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Room %s", (yyvsp[-1].strval));
		  YYABORT;
		}
	      }
#line 1876 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 78:
#line 495 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		if (gt_add_door((yyvsp[-1].strval), (yyvsp[0].coords)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Door %s", (yyvsp[-1].strval));
		  YYABORT;
		}
	      }
#line 1887 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 79:
#line 505 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		if (gt_add_hallway((yyvsp[-6].strval), (yyvsp[-4].coords), (yyvsp[-2].fval), (yyvsp[0].coords)) != GT_SUCCESS) {
		  odl_errorf("Unable to add Hallway %s", (yyvsp[-6].strval));
		  YYABORT;
		}
	      }
#line 1898 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 80:
#line 515 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		if (gt_load_waypoint_file((yyvsp[0].strval)) != GT_SUCCESS)
		{
		  /* Keep parsing even if the file is not loaded. */
		}
	      }
#line 1909 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 81:
#line 525 "gt_overlay_yac.y" /* yacc.c:1646  */
    {  (yyval.coords) = (yyvsp[0].coords); }
#line 1915 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 82:
#line 527 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
		   gt_Point_list *pt = (yyvsp[-1].coords);
		   while (pt->next)
		      pt = pt->next;
		   pt->next = (yyvsp[0].coords);
		   (yyval.coords) = (yyvsp[-1].coords);
		}
#line 1927 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 83:
#line 539 "gt_overlay_yac.y" /* yacc.c:1646  */
    { 
     if (((yyval.coords) = (gt_Point_list *)malloc(sizeof(gt_Point_list))) == NULL) {
       fprintf(stderr, "Ran out of memory creating coordinate pair (%f %f)",
	       (yyvsp[-1].fval), (yyvsp[0].fval));
       odl_errorf("Ran out of memory creating coordinate pair (%f %f)",
		  (yyvsp[-1].fval), (yyvsp[0].fval));
       YYABORT;
     }
     (yyval.coords)->x = (yyvsp[-1].fval) + origin_x;
     (yyval.coords)->y = (yyvsp[0].fval) + origin_y;
     (yyval.coords)->next = 0;
   }
#line 1944 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 84:
#line 551 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
     if (((yyval.coords) = (gt_Point_list *)malloc(sizeof(gt_Point_list))) == NULL) {
       fprintf(stderr, "Ran out of memory creating coordinate pair");
       odl_errorf("Ran out of memory creating coordinate pair");
       YYABORT;
     }
     
     (yyval.coords)->x = (yyvsp[0].utm_coord)[0] - origin_x;
     (yyval.coords)->y = (yyvsp[0].utm_coord)[1] - origin_y;
     (yyval.coords)->next = 0;
   }
#line 1960 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 85:
#line 565 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
     gt_convert_latlon_to_utm((yyvsp[-2].fval), (yyvsp[0].fval), &utmx, &utmy);
     (yyval.utm_coord)[0] = utmx;
     (yyval.utm_coord)[1] = utmy;
   }
#line 1970 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;

  case 86:
#line 570 "gt_overlay_yac.y" /* yacc.c:1646  */
    {
     gt_convert_latlon_to_utm((yyvsp[0].fval), (yyvsp[-2].fval), &utmx, &utmy);
     (yyval.utm_coord)[0] = utmx;
     (yyval.utm_coord)[1] = utmy;
   }
#line 1980 "gt_overlay_yac.c" /* yacc.c:1646  */
    break;


#line 1984 "gt_overlay_yac.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 581 "gt_overlay_yac.y" /* yacc.c:1906  */



/**********************************************************************
 * $Log: gt_overlay_yac.y,v $
 * Revision 1.1.1.1  2008/07/14 16:44:22  endo
 * MAST Project (based on MissionLab-MINOS-20071018.tar.gz)
 *
 * Revision 1.7  2007/08/10 04:41:06  pulam
 * Added scale fix and military unit drawing fix.
 *
 * Revision 1.6  2007/03/12 06:04:07  nadeem
 * Modified code to remove the overloading and hence notational abuse of MISSION-AREA statement in the .ovl file
 *
 * Revision 1.5  2007/03/12 00:06:33  nadeem
 * Fixed code so that the mission area is expressed in meters internally for simulations.
 *
 * Revision 1.4  2007/03/06 05:06:52  nadeem
 * Modified code to use Mercator projection to map between lat/lon and X/Y positions.
 *
 * Revision 1.3  2006/09/26 18:33:50  endo
 * ICARUS Wizard integrated with Lat/Lon.
 *
 * Revision 1.2  2006/09/20 18:34:48  nadeem
 * Added the code to convert latitude/longitude to X/Y and vice-versa. A lot of files had to be touched to make sure that the initialisation values can flow across from mlab to the robot executables as well as to ensure that the functions were available for use on both sides of the code.
 *
 * Revision 1.1.1.1  2006/07/20 17:17:50  endo
 * MINOS Project (based on MissionLab-7.0.20060712.tar.gz)
 *
 * Revision 1.1.1.1  2006/07/12 13:37:59  endo
 * MissionLab 7.0
 *
 * Revision 1.6  2006/07/11 10:07:49  endo
 * CMDLi Panel merged from MARS 2020.
 *
 * Revision 1.5  2005/07/23 05:58:20  endo
 * 3D visualization improved.
 *
 * Revision 1.4  2005/05/18 21:01:55  endo
 * Conflicts by previous mod resolved.
 *
 * Revision 1.3  2005/04/22 23:01:45  endo
 * Heightmap now accepts '*.*' as its name.
 *
 * Revision 1.2  2005/03/23 07:36:55  pulam
 * *** empty log message ***
 *
 * Revision 1.1.1.1  2005/02/06 23:00:10  endo
 * AO-FNC Project (based on mlab-6.0.01.06192003.tar.gz)
 *
 * Revision 1.36  2000/07/07 18:16:52  endo
 * waypoint_file_statement added.
 *
 * Revision 1.35  2000/04/25 09:43:22  jdiaz
 * *** empty log message ***
 *
 * Revision 1.34  2000/02/07 05:14:26  jdiaz
 * doorways walls hallways rooms
 *
 * Revision 1.33  1999/08/31 15:12:39  endo
 * *** empty log message ***
 *
 * Revision 1.32  1999/08/30 21:33:53  jdiaz
 * add utm_coordinate rules for UTM translations
 *
 * Revision 1.31  1997/02/14 15:49:30  zchen
 * *** empty log message ***
 *
 * Revision 1.30  1996/02/16  00:06:44  doug
 * *** empty log message ***
 *
 * Revision 1.29  1996/02/08  19:24:07  doug
 * handle objects of any color
 *
 * Revision 1.28  1995/11/07  14:31:57  doug
 * added baskets and command to drop oranges into them
 *
 * Revision 1.27  1995/10/03  21:25:06  doug
 * add support for get_objects call
 *
 * Revision 1.26  1995/10/03  15:48:58  doug
 * attractor support added to control diameter
 *
 * Revision 1.25  1995/10/03  15:44:00  doug
 * added attractor statement
 *
 * Revision 1.24  1995/06/12  16:17:39  jmc
 * Added load_map_statement.
 *
 * Revision 1.23  1995/05/08  17:47:33  jmc
 * Changed old reference to mpp to zoom_factor.
 *
 * Revision 1.22  1995/05/06  00:43:28  jmc
 * Changed the grammar for SET METERS-PER-PIXEL to SET ZOOM-FACTOR.
 *
 * Revision 1.21  1995/05/04  22:05:11  jmc
 * Added include for gt_scale.h since all the scale related functions
 * moved to it.
 *
 * Revision 1.20  1995/05/02  21:21:16  jmc
 * Added grammar for SET METERS-PER-PIXEL statement.
 *
 * Revision 1.19  1995/05/02  19:49:49  jmc
 * Changed WORK-AREA to MISSION-AREA.
 *
 * Revision 1.18  1995/05/02  18:56:06  jmc
 * Added grammar for WORK-AREA statement.
 *
 * Revision 1.17  1995/04/20  18:18:31  jmc
 * Corrected spelling.
 *
 * Revision 1.16  1995/04/19  22:20:18  jmc
 * Added a fprintf(stderr, ...) message for running out of memory
 * since it may not be possible to pop up the warn_user interface at
 * that point.
 *
 * Revision 1.15  1995/04/14  21:25:52  jmc
 * Removed the defaults for the diameter/width of some control
 * measures (put those defaults in gt_console_db.c).  The gt_add_*
 * functions in gt_console_db.c know to use the default values by the
 * negative values specified in this file.
 *
 * Revision 1.14  1995/04/05  21:14:47  jmc
 * Added grammar for starting point.
 *
 * Revision 1.13  1995/04/05  20:36:15  jmc
 * Converted OBSTACLE rule to coordinate_pair (from NUMBER NUMBER) to
 * make it consistent with all the other rules.
 *
 * Revision 1.12  1995/04/04  20:54:03  jmc
 * Cosmetic changes: Reindented the statement rules to narrow them.
 * Alphabetized the statement rules.
 *
 * Revision 1.11  1995/04/03  20:28:05  jmc
 * Added copyright notice.
 *
 * Revision 1.10  1994/11/07  20:11:33  jmc
 * Small mods to make sure that everything uses the origin correctly.
 *
 * Revision 1.9  1994/11/07  19:56:13  jmc
 * Changed origin_x and origin_y to use globals now defined in
 * gt_world.c.
 *
 * Revision 1.8  1994/11/07  17:23:20  jmc
 * Implemented the grammar to add obstacles (OBSTACLE x y r).
 *
 * Revision 1.7  1994/10/25  20:23:23  jmc
 * Added syntax to optionally allow specifying the diameter of
 * passage points, attack positions, battle positions, and
 * objectives.
 *
 * Revision 1.6  1994/08/18  19:28:12  doug
 * Converted SUCCESS/FAILURE to GT_SUCCESS/GT_FAILURE
 *
 * Revision 1.5  1994/08/04  18:37:10  jmc
 * Added grammar for optional width on axis_statement and
 * gap_statement.
 *
 * Revision 1.4  1994/08/03  16:57:35  jmc
 * Added error trapping for errors in add_* functions calls using the
 * odl_error function and YYABORT.
 *
 * Revision 1.3  1994/07/12  19:22:27  jmc
 * Tweaked RCS automatic identification strings
 *
 * Revision 1.2  1994/07/12  17:34:45  jmc
 * Added RCS automatic identification strings
 **********************************************************************/
